=== debian/changelog ===
vulkan-tools (1.4.304.0+dfsg1-1) unstable; urgency=medium

  * New upstream release. (Closes: #1093365)
  * control: Bump build-deps.

  [ Pino Toscano ]
  * Enable the build on all the architectures, as this source is generally
    portable, and upstream accepts ports:
    - switch the architecture of the binaries from linux-any to any
    - Wayland is still Linux-specific, so:
      - limit the libwayland-dev, and wayland-protocols build dependencies
        as linux-any
      - pass -DBUILD_WSI_WAYLAND_SUPPORT=OFF to cmake on non-Linux
        architectures to explicitly disable the Wayland integration

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 15 Feb 2025 09:09:02 +0200
