=== vulkaninfo/CMakeLists.txt ===
--- 
+++ 
@@ -109,7 +109,6 @@
 target_link_libraries(vulkaninfo PRIVATE
     Vulkan::Headers
     ${CMAKE_DL_LIBS}
-    volk::volk_headers
 )
 
 if(WIN32)
