=== debian/changelog ===
vulkan-tools (1.4.321.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-deps.
  * patches: Fix build.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 27 Aug 2025 10:14:00 +0300
