=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Build-Depends: debhelper-compat (= 13),
  cmake,
  glslang-tools,
- libvulkan-dev (>= 1.4.304.0),
- libvulkan-volk-dev (>= 1.4.304.0),
+ libvulkan-dev (>= 1.4.321.0),
+ libvulkan-volk-dev (>= 1.4.321.0),
  libwayland-dev [linux-any],
  libx11-dev,
  libxcb1-dev,
