## vulkan-tools 1.4.328.1+dfsg1

=== scripts/CMakeLists.txt ===
--- 
+++ 
@@ -121,9 +121,6 @@
 if (VULKAN_HEADERS_INSTALL_DIR)
     list(APPEND CMAKE_PREFIX_PATH ${VULKAN_HEADERS_INSTALL_DIR})
 endif()
-if (VOLK_INSTALL_DIR)
-    list(APPEND CMAKE_PREFIX_PATH ${VOLK_INSTALL_DIR})
-endif()
 if (GOOGLETEST_INSTALL_DIR)
     list(APPEND CMAKE_PREFIX_PATH ${GOOGLETEST_INSTALL_DIR})
 endif()
