=== debian/changelog ===
vulkan-tools (1.4.328.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-deps.
  * watch: Updated.
  * patches: Drop upstreamed patch.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 10 Nov 2025 17:56:50 +0200
