=== debian/watch ===
Version: 5

Template: Github
Owner: KhronosGroup
Project: Vulkan-Tools
Dversion-Mangle: s/\+dfsg1//
Repack-Suffix: +dfsg1
